wfcreate(wf=consumption,page=data) q 1985.1 2007.4

smpl 1985.1 2007.4
read(e,b2,s=cr) consumption.xls cr_ge cr_uk cr_fr cr_it cr_bl cr_nl cr_us cr_ca cr_jp cr_oe cr_es cr_po cr_ir cr_fn
read(e,b2,s=yr) consumption.xls yr_ge yr_uk yr_fr yr_it yr_bl yr_nl yr_us yr_ca yr_jp yr_oe yr_es yr_po yr_ir yr_fn
read(e,b2,s=ced) consumption.xls ced_ge ced_uk ced_fr ced_it ced_bl ced_nl ced_us ced_ca ced_jp ced_oe ced_es ced_po ced_ir ced_fn
read(e,b2,s=cpi) consumption.xls cpi_ge cpi_uk cpi_fr cpi_it cpi_bl cpi_nl cpi_us cpi_ca cpi_jp cpi_oe cpi_es cpi_po cpi_ir cpi_fn
read(e,b2,s=u) consumption.xls u_ge u_uk u_fr u_it u_bl u_nl u_us u_ca u_jp u_oe u_es u_po u_ir u_fn
read(e,b2,s=hp) consumption.xls hp_ge hp_uk hp_fr hp_it hp_bl hp_nl hp_us hp_ca hp_jp hp_oe hp_es hp_po hp_ir hp_fn
read(e,b2,s=sp) consumption.xls sp_ge sp_uk sp_fr sp_it sp_bl sp_nl sp_us sp_ca sp_jp sp_oe sp_es sp_po sp_ir sp_fn

pool countries _ge _uk _fr _it _bl _nl _us _ca _jp _oe _es _po _ir _fn

countries.genr lcr?=log(cr?)
countries.genr lyr?=log(yr?)
countries.genr lhpr?=log(100*hp?/cpi?)
countries.genr lspr?=log(100*sp?/cpi?)

countries.genr dlcr?=d(lcr?)
countries.genr dlyr?=d(lyr?)
countries.genr dlhpr?=d(lhpr?)
countries.genr dlspr?=d(lspr?)
countries.genr du?=d(u?)
countries.genr dlcpi?=d(log(cpi?))

smpl 1991.1 2007.4
'
'POOLED ESTIMATION OF COINTEGRATING VECTOR
freeze(_mod1) countries.ls(cx=f,wgt=cxsur) lcr? lyr? lhpr?
freeze(_mod2) countries.ls(cx=f,wgt=cxsur) lcr? lyr? lspr?
freeze(_mod3) countries.ls(cx=f,wgt=cxsur) lcr? lyr? lhpr? lspr? 

'ERROR CORRECTION MODELS
countries.genr ecm1?=lcr?-1.081*lyr?-0.019*lhpr?
countries.genr ecm2?=lcr?-1.016*lyr?-0.029*lspr?
countries.genr ecm3?=lcr?-1.000*lyr?-0.024*lhpr?-0.030*lspr?

freeze(_ec1) countries.ls(cx=f,wgt=cxsur) dlcr? ecm1?(-1) dlyr? dlcpi? dlcpi?(-1) dlhpr?
freeze(_ec2) countries.ls(cx=f,wgt=cxsur) dlcr? ecm2?(-1) dlyr? dlcpi? dlcpi?(-1) dlhpr?
freeze(_ec3) countries.ls(cx=f,wgt=cxsur) dlcr? ecm3?(-1) dlyr? dlcpi? dlcpi?(-1) dlhpr?

freeze(_ec1_) countries.ls(cx=f,wgt=cxsur) dlcr? dlyr? dlcpi? dlcpi?(-1) dlhpr? @ ecm1?(-1)
freeze(_ec2_) countries.ls(cx=f,wgt=cxsur) dlcr? dlyr? dlcpi? dlcpi?(-1) dlhpr?  @ ecm2?(-1)
freeze(_ec3_) countries.ls(cx=f,wgt=cxsur) dlcr? dlyr? dlcpi? dlcpi?(-1) dlhpr?  @ ecm3?(-1)

'ENGLE GRANGER REGRESSIONS

smpl 1991.1 2007.4
for %c _ge _uk _fr _it _bl _nl _us _ca _jp _oe _es _po _ir _fn
equation eq_spr{%c}
eq_spr{%c}.ls lcr{%c} c lyr{%c} lspr{%c}
equation eq_hpr{%c}
eq_hpr{%c}.ls lcr{%c} c lyr{%c} lhpr{%c}
next

'PRINCIPAL COMPONENTS, DIFFERENCED DATA

group dlcr dlcr_ge
group dlyr dlyr_ge
group dlhpr dlhpr_ge
group dlspr dlspr_ge 
for %c _uk _fr _it _bl _nl _us _ca _jp _oe _es _po _ir _fn
dlcr.add dlcr{%c}
dlyr.add dlyr{%c}
dlhpr.add dlhpr{%c}
dlspr.add dlspr{%c}
next

smpl 1991.1 2007.4
freeze(_dlcr) dlcr.pcomp(eigval=ea,eigvec=ev) dpc1 dpc2
freeze(_dlyr) dlyr.pcomp(eigval=ea,eigvec=ev) dpy1 dpy2
freeze(_dlhpr) dlhpr.pcomp(eigval=ea,eigvec=ev) dphp1 dphp2
freeze(_dlspr) dlspr.pcomp(eigval=ea,eigvec=ev) dpsp1 dpsp2

'IDIOSYNCRATIC COMPONENTS

smpl 1991.1 2007.4
for %c _ge _uk _fr _it _bl _nl _us _ca _jp _oe _es _po _ir _fn
equation eq_dc{%c}
eq_dc{%c}.ls dlcr{%c} c dpc1
eq_dc{%c}.makeresid dic{%c}
equation eq_dy{%c}
eq_dy{%c}.ls dlyr{%c} c dpy1
eq_dy{%c}.makeresid diy{%c}
equation eq_dhp{%c}
eq_dhp{%c}.ls dlhpr{%c} c dphp1
eq_dhp{%c}.makeresid dihp{%c}
equation eq_dsp{%c}
eq_dsp{%c}.ls dlspr{%c} c dpsp1
eq_dsp{%c}.makeresid disp{%c}
next

'CUMULATING COMMON AND IDIOSYNCRATIC COMPONENTS

smpl 1991.1 1991.1
genr pc1=dpc1
genr py1=dpy1
genr php1=dphp1
genr psp1=dpsp1

smpl 1991.2 2007.4
genr pc1=pc1(-1)+dpc1
genr py1=py1(-1)+dpy1
genr php1=php1(-1)+dphp1
genr psp1=psp1(-1)+dpsp1

'CUMULATING WITH EMPIRICAL MOMENTS

smpl 1991.1 2007.4
genr pc11=@rmean(dlcr)+@rstdev(dlcr)*dpc1
genr py11=@rmean(dlyr)+@rstdev(dlyr)*dpy1
genr psp11=@rmean(dlspr)+@rstdev(dlspr)*dpsp1
genr php11=@rmean(dlhpr)+@rstdev(dlhpr)*dphp1

smpl 1991.1 1991.1
genr kpc1=pc11
genr kpy1=py11
genr kpsp1=psp11
genr kphp1=php11

smpl 1991.2 2007.4
genr kpc1=kpc1(-1)+pc11
genr kpy1=kpy1(-1)+py11
genr kpsp1=kpsp1(-1)+psp11
genr kphp1=kphp1(-1)+php11

smpl 1991.1 1991.1
for %c _ge _uk _fr _it _bl _nl _us _ca _jp _oe _es _po _ir _fn
genr ic{%c}=dic{%c}
genr iy{%c}=diy{%c}
genr ihp{%c}=dihp{%c}
genr isp{%c}=disp{%c}
next

smpl 1991.2 2007.4
for %c _ge _uk _fr _it _bl _nl _us _ca _jp _oe _es _po _ir _fn
genr ic{%c}=ic{%c}(-1)+dic{%c}
genr iy{%c}=iy{%c}(-1)+diy{%c}
genr ihp{%c}=ihp{%c}(-1)+dihp{%c}
genr isp{%c}=isp{%c}(-1)+disp{%c}
next

'PANIC FOR COMMON AND IDIOSYNCRATIC COMPONENTS

smpl 1991.1 2007.4
group ic ic_ge
group iy iy_ge
group ihp ihp_ge
group isp isp_ge

for %c _uk _fr _it _bl _nl _us _ca _jp _oe _es _po _ir _fn
ic.add ic{%c}
iy.add iy{%c}
ihp.add ihp{%c}
isp.add isp{%c}
next

'PERFORM ADF TEST FOR COMMON COMPONENTS
'PERFORM IPS TEST FOR IDIOSYNCRATIC COMPONENTS (GROUPS) 

'COINTEGRATION ANALYSIS FOR COMMON COMPONENTS
group _joh_hp pc1 py1 php1
group _joh_sp pc1 py1 psp1
group _joh_ps pc1 py1 php1 psp1

'DOLS COINTEGRATION VECTOR FOR COMMON COMPONENTS
equation _eq_spr
_eq_spr.ls kpc1 c kpy1 kpsp1 d(kpy1(2)) d(kpy1(-1)) d(kpy1(-2))

equation _eq_hpr
_eq_hpr.ls kpc1 c kpy1 kphp1 d(kpy1(2)) d(kpy1(1)) d(kpy1(-2)) d(kphp1) d(kphp1(-2))

equation _eq_psr
_eq_psr.ls kpc1 c kpy1 kpsp1 kphp1 d(kpy1(2)) d(kpy1(1)) d(kpy1) d(kphp1)

'COINTEGRATION ANALYSIS FOR IDIOSYNCRATIC COMPONENTS
pagestack(page=panel) _ge _uk _fr _it _bl _nl _us _ca _jp _oe _es _po _ir _fn @ ic? iy? ihp? isp?

group _ped_hp ic iy ihp
group _ped_sp ic iy isp
group _ped_hs ic iy ihp isp

_ped_hp.coint(pedroni,const,info=sic)
_ped_sp.coint(pedroni,const,info=sic)
_ped_hs.coint(pedroni,const,info=sic)

